#ifndef INCLUSION_GUARD_ObjGrammar_H
#define INCLUSION_GUARD_ObjGrammar_H

#include <iostream>
using std::cout;
using std::endl;

#include <memory>

// Mammut-generated parser file

class ObjGrammar_Types
{
public:
	struct STYPE
	{ 
		int itype;
		double dtype;
		char *stype;
	};

	struct LTYPE
	{
		int first_line, first_column;
		int last_line, last_column;
		char *text;
	};

	enum Tokens {
		NULL_TOKEN=0, INTEGER=258, FLOAT=259, GROUP=260, USEMTL=261, VERTEX=262, TEXCOORD=263, NORMAL=264, FACE=265, SMOOTH=266, ENDL=267, 
SLASH=268
	};

	enum Defines {
		YYFINAL=47, YYFLAG=32768, YYNTBASE=14, YYLAST=35
	};

	static int Translate(unsigned int x)
	{
		if (x <= 268)
			return yytranslate[x];
		else
			return 28;
	}

	static const short yypact[];
	static const short yypgoto[];
	static const char yytranslate[];
	static const short yyrline[];
	static const char * const yytname[];
	static const short yyr1[];
	static const short yyr2[];
	static const short yytable[];
	static const short yycheck[];
	static const short yydefact[];
	static const short yyprhs[];
	static const short yyrhs[];
	static const short yydefgoto[];
};

template<typename Actions>
class ObjGrammar_base : public Actions
{
public:
	void Action(int yyn,
		ObjGrammar_Types::STYPE &yyval,
		ObjGrammar_Types::STYPE *yyvsp)
	{
		switch(yyn)
		{
			
case 13:
{ act->AddVertex(yyvsp[-2].dtype, yyvsp[-1].dtype, yyvsp[0].dtype); ;
	break; }
case 14:
{ act->AddTexcoord(yyvsp[-1].dtype,yyvsp[0].dtype); ;
	break; }
case 15:
{ act->AddTexcoord(yyvsp[-2].dtype,yyvsp[-1].dtype,yyvsp[0].dtype); ;
	break; }
case 16:
{ cout << "Normal: " << yyvsp[-2].dtype << ',' << yyvsp[-1].dtype << ',' << yyvsp[0].dtype << endl; ;
	break; }
case 24:
{ cout << "Smoothgroup: " << yyvsp[0].itype << endl; ;
	break; }
case 25:
{ cout << "Group: \"" << yyvsp[0].stype << "\"" << endl; free(yyvsp[0].stype); ;
	break; }
case 26:
{ cout << "UseMtl: \"" << yyvsp[0].stype << "\"" << endl; free(yyvsp[0].stype); ;
	break; }
case 27:
{ yyval.dtype = yyvsp[0].itype; ;
	break; }
		default:
			break;
		}
	}
};

template<typename Actions>
class DelegatedActions
{
protected:
	std::auto_ptr<Actions> act;
};

template<typename Actions>
class SharedActions
{
protected:
	Actions * act;
};

template<typename Actions>
class ObjGrammar :
	public ObjGrammar_base<DelegatedActions<Actions> >,
	public ObjGrammar_Types	
{
public:
	ObjGrammar(Actions * a = new Actions) { act = std::auto_ptr<Actions>(a); }
};

template<typename Actions>
class ObjGrammar_Shared :
	public ObjGrammar_base<SharedActions<Actions> >,
	public ObjGrammar_Types	
{
public:
	ObjGrammar_Shared(Actions & a) { act = &a; }
};

template<typename Actions>
class ObjGrammar_Mixin :
	public ObjGrammar_base<Actions>,
	public ObjGrammar_Types
{
};

#endif // INCLUSION_GUARD_ObjGrammar_H
