// Mammut default parser definition
#include <Mammut/Parser.h>

// Language specific parser header generated by mammut
#include "ObjParser.h"

// Lexer generated by flex++ (modified version that supports STL correctly)
#include "testlexer.h"

#include <fstream>

using namespace std;
using namespace Mammut;

class ObjActions
{
public:
	void AddVertex(double x, double y, double z)
	{
		cout << "Vertex: " << x << ',' << y << ',' << z << endl;
	}

	void AddTexcoord(double u, double v, double w=0)
	{
		cout << "Texcord: " << u << ',' << v << ',' << w << endl;
	}
};

int main()
{
	ifstream is("cube.obj");
	if(is.good())
	{
		ObjGrammar<ObjActions> grammar;
		Flex<ObjLexer> lexer(is);

		//parse(lexer, grammar);
		parse<ConsoleDebug>(lexer, grammar);
	}
	else
		cerr << "Could not open file..." << endl;

	return 0;
}
