/*
Mammut parser generator
Copyright (C) 2005 Lumai HB - http://www.lumai.se
This source code is based on Bison++ by Alain Coetmeur.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
02110-1301, USA
*/


#include "machine.h"

// Given n by n matrix of bits R, modify its contents to be the transive closure of what was given.

void TC(unsigned int* R, int n)
{
	int const rowsize = WORDSIZE(n) * sizeof(unsigned);
	unsigned * const relend = (unsigned *) ((char *) R + (n * rowsize));
	
	unsigned *cword = R;
	unsigned mask = 1;
	unsigned *rowi = R;
	while (rowi < relend)
    {
		unsigned *ccol = cword;
		unsigned *rowj = R;
		
		while (rowj < relend)
		{
			if (*ccol & mask)
			{
				unsigned *rp = rowi;
				unsigned *rend = (unsigned *) ((char *) rowj + rowsize);
				
				while (rowj < rend)
					*rowj++ |= *rp++;
			}
			else
				rowj = (unsigned *) ((char *) rowj + rowsize);
			
			ccol = (unsigned *) ((char *) ccol + rowsize);
		}
		
		mask <<= 1;
		if (mask == 0)
		{
			mask = 1;
			cword++;
		}
		
		rowi = (unsigned *) ((char *) rowi + rowsize);
    }
}


// Reflexive Transitive Closure. Same as TC and then set all the bits on the diagonal of R.

void RTC(unsigned int* R, int n)
{
	TC(R, n);
	
	int const rowsize = WORDSIZE(n) * sizeof(unsigned);
	unsigned * const relend = (unsigned *) ((char *) R + n*rowsize);	
	unsigned mask = 1;
	unsigned *rp = R;
	while (rp < relend)
    {
		*rp |= mask;
		
		mask <<= 1;
		if (mask == 0)
		{
			mask = 1;
			rp++;
		}
		
		rp = (unsigned *) ((char *) rp + rowsize);
    }
}
